#include <h5edit_config.h>
#include <stdio.h>
#include <stdlib.h>
#include <private_definition.h>
#include <hdf5.h>
#include <hdf5_hl.h>
#include <assert.h>

/* Macro definitions */
#define EXIT_FAILURE	1
#define EXIT_SUCCESS	0
#ifndef	FALSE
    #define FALSE	0
#endif
#ifndef TRUE
    #define TRUE	!FALSE
#endif
#define streq(s1, s2)	!HDstrcmp(s1, s2)

/* Version information of the tool. It consists of:
 * Major version: increases whenever there are major feature changes;
 * Minor version: increases whenever there are feature changes;
 * Release:       increases whenever officially released.
 */
#define H5EDIT_VER_MAJOR    1 
#define H5EDIT_VER_MINOR    0 
#define H5EDIT_VER_RELEASE  0 
#define H5EDIT_RELEASE_DATE "released July 31, 2011"
#define	H5EDIT_VERSION_FORMAT_STRING	"H5edit version %d.%d.%d, %s"


/* Global types declaration. */
typedef	enum object_t {No_type, Dataset_type, Group_type} object_t;

/* Global variables declaration. */
/* Option flags */
extern	int	dryrun_g;
extern	const char	*datafilename_g;
extern	const char	*commfilename_g;
extern	const char	*command_g;
extern	const char	*progname_g;
extern	hid_t		datafile_g;
extern	FILE		*commfile_g;

/* other global variables */

/* lex and yacc definitions */
extern int	h5edit_input_len;
extern char	*h5edit_command;
extern FILE	*h5edit_commfile;
extern int	H5EDITyyparse(void);

/* Prototypes */
void parse_option(int ac, const char** av);
void leave(int ret);
void usage(void);
hid_t opendatafile(const char *name);
FILE *opencommfile(const char *name);
void execute_command(void);
void set_debug(void);
int get_debug(void);
int create_attribute(const char *attribute_name, const char *group_name,
    const char *dataset_name, hid_t type_id, hid_t space_id, void *data);
int delete_attribute(const char *attribute_name, const char *group_name,
    const char *dataset_name);
void print_version(void);

