#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define yyparse H5EDITyyparse
#define yylex H5EDITyylex
#define yyerror H5EDITyyerror
#define yychar H5EDITyychar
#define yyval H5EDITyyval
#define yylval H5EDITyylval
#define yydebug H5EDITyydebug
#define yynerrs H5EDITyynerrs
#define yyerrflag H5EDITyyerrflag
#define yyss H5EDITyyss
#define yyssp H5EDITyyssp
#define yyvs H5EDITyyvs
#define yyvsp H5EDITyyvsp
#define yylhs H5EDITyylhs
#define yylen H5EDITyylen
#define yydefred H5EDITyydefred
#define yydgoto H5EDITyydgoto
#define yysindex H5EDITyysindex
#define yyrindex H5EDITyyrindex
#define yygindex H5EDITyygindex
#define yytable H5EDITyytable
#define yycheck H5EDITyycheck
#define yyname H5EDITyyname
#define yyrule H5EDITyyrule
#define yysslim H5EDITyysslim
#define yystacksize H5EDITyystacksize
#define YYPREFIX "H5EDITyy"
#line 11 "parse.y"
#include<h5edit.h>

extern int yylex();
extern int yyerror(char *);

#define STACK_SIZE      16
#define DATA_SIZE_MAX	512	/* max number of data points */

/* types definitions */
/* nothing yet */

/* variables */
/* Attribute name and handle */
char		*attribute_name = NULL;
hid_t		attribute_id = -1;
char		*attribute_type_name = NULL;
hid_t		attribute_type_id = -1;
H5T_class_t	attribute_type_class = H5T_NO_CLASS;
hid_t		attribute_space_id = -1;
H5S_class_t	attribute_space_class = H5S_NO_CLASS;
H5T_class_t	data_value_class = H5T_NO_CLASS;
struct arr_info	attribute_dims;			/* attribute dimension */


		/* attribute data buffer */
/*void		*attribute_data = NULL; */
		/* this approach does not work for compound types */
union {
    int		data_int[DATA_SIZE_MAX];	/* attribute integer data */
    double	data_float[DATA_SIZE_MAX];	/* attribute float data */
    char	data_string[DATA_SIZE_MAX];	/* attribute string data */
    char	data_char[DATA_SIZE_MAX];	/* for SCALAR string data */
} attribute_data;
int		attribute_data_needed = -1;
int		attribute_data_gotten = -1;
		/* points to available string data buffer */
char*		attribute_data_pt = &(attribute_data.data_string);



/* Dataset name and handle */
char	*group_name = NULL;
char	*dataset_name = NULL;
hid_t	dataset_id = -1;

/*structure for array type information*/
struct arr_info {
    hsize_t	dims[H5S_MAX_RANK];     /*size of each dimension, limited to 32 dimensions*/
    int		ndims;                  /*number of dimensions*/
    hbool_t	is_dim;                 /*flag to lexer for dimension*/
};


/*structure for compound type information*/
struct cmpd_info {
    hid_t       id;             /*type ID*/
    hbool_t     is_field;       /*flag to lexer for compound member*/
    hbool_t     first_memb;     /*flag for first compound member*/
};

/*stack for nested compound type*/
struct cmpd_info h5edit_cmpd_stack[STACK_SIZE] = {
    {0, 0, 1}, {0, 0, 1}, {0, 0, 1}, {0, 0, 1},
    {0, 0, 1}, {0, 0, 1}, {0, 0, 1}, {0, 0, 1},
    {0, 0, 1}, {0, 0, 1}, {0, 0, 1}, {0, 0, 1},
    {0, 0, 1}, {0, 0, 1}, {0, 0, 1}, {0, 0, 1} };

int h5edit_csindex = -1;                /*pointer to the top of compound stack*/

/*stack for nested array type*/
struct arr_info arr_stack[STACK_SIZE];
int h5edit_asindex = -1;               /*pointer to the top of array stack*/ 

hbool_t     h5edit_is_str_size = 0;        /*flag to lexer for string size*/
/*hbool_t     is_str_pad = 0;         */ /*flag to lexer for string padding*/
H5T_pad_t   str_pad;                /*variable for string padding*/
H5T_cset_t  str_cset;               /*variable for string character set*/
hbool_t     h5edit_is_variable = 0;        /*variable for variable-length string*/
int      str_size;               /*variable for string size*/
   

#line 93 "parse.y"
typedef union {
    int   ival;         /*for integer token*/
    double fval;	/*for floating point token */
    char  *sval;        /*for name string*/
} YYSTYPE;
#line 131 "parse.c"
#define YYERRCODE 256
#define CREATE_KWORD 257
#define DELETE_KWORD 258
#define ATTRIBUTE_KWORD 259
#define DATASET_KWORD 260
#define GROUP_KWORD 261
#define DATATYPE_KWORD 262
#define DATASPACE_KWORD 263
#define DATA_KWORD 264
#define IDENTIFIER 265
#define PATHNAME 266
#define QUOTED_STRING 267
#define DQUOTED_STRING 268
#define EOSTMT_TOKEN 269
#define WSPACE 270
#define INTEGER_TYPE_TOKEN 271
#define FLOAT_TYPE_TOKEN 272
#define H5T_STD_I8BE_TOKEN 273
#define H5T_STD_I8LE_TOKEN 274
#define H5T_STD_I16BE_TOKEN 275
#define H5T_STD_I16LE_TOKEN 276
#define H5T_STD_I32BE_TOKEN 277
#define H5T_STD_I32LE_TOKEN 278
#define H5T_STD_I64BE_TOKEN 279
#define H5T_STD_I64LE_TOKEN 280
#define H5T_STD_U8BE_TOKEN 281
#define H5T_STD_U8LE_TOKEN 282
#define H5T_STD_U16BE_TOKEN 283
#define H5T_STD_U16LE_TOKEN 284
#define H5T_STD_U32BE_TOKEN 285
#define H5T_STD_U32LE_TOKEN 286
#define H5T_STD_U64BE_TOKEN 287
#define H5T_STD_U64LE_TOKEN 288
#define H5T_NATIVE_CHAR_TOKEN 289
#define H5T_NATIVE_SCHAR_TOKEN 290
#define H5T_NATIVE_UCHAR_TOKEN 291
#define H5T_NATIVE_SHORT_TOKEN 292
#define H5T_NATIVE_USHORT_TOKEN 293
#define H5T_NATIVE_INT_TOKEN 294
#define H5T_NATIVE_UINT_TOKEN 295
#define H5T_NATIVE_LONG_TOKEN 296
#define H5T_NATIVE_ULONG_TOKEN 297
#define H5T_NATIVE_LLONG_TOKEN 298
#define H5T_NATIVE_ULLONG_TOKEN 299
#define H5T_IEEE_F32BE_TOKEN 300
#define H5T_IEEE_F32LE_TOKEN 301
#define H5T_IEEE_F64BE_TOKEN 302
#define H5T_IEEE_F64LE_TOKEN 303
#define H5T_NATIVE_FLOAT_TOKEN 304
#define H5T_NATIVE_DOUBLE_TOKEN 305
#define H5T_NATIVE_LDOUBLE_TOKEN 306
#define H5T_STRING_TOKEN 307
#define STRSIZE_TOKEN 308
#define STRPAD_TOKEN 309
#define CSET_TOKEN 310
#define CTYPE_TOKEN 311
#define H5T_VARIABLE_TOKEN 312
#define H5T_STR_NULLTERM_TOKEN 313
#define H5T_STR_NULLPAD_TOKEN 314
#define H5T_STR_SPACEPAD_TOKEN 315
#define H5T_CSET_ASCII_TOKEN 316
#define H5T_CSET_UTF8_TOKEN 317
#define H5T_C_S1_TOKEN 318
#define H5T_FORTRAN_S1_TOKEN 319
#define H5T_COMPOUND_TOKEN 320
#define H5T_ARRAY_TOKEN 321
#define H5T_VLEN_TOKEN 322
#define STRING_CONST 323
#define INTEGER_CONST 324
#define FLOAT_CONST 325
#define SCALAR_TOKEN 326
#define SIMPLE_TOKEN 327
#define NULL_TOKEN 328
const short H5EDITyylhs[] = {                                        -1,
    0,    0,    1,    2,    2,    4,    4,    5,    5,    6,
    7,    8,    9,   12,   10,   10,   10,   14,   15,   13,
   13,   13,   13,    3,   11,   16,   16,   16,   16,   17,
   17,   20,   21,   21,   21,   24,   25,   26,   27,   27,
   22,   23,   18,   18,   28,   28,   28,   30,   29,   29,
   33,   32,   34,   35,   35,   36,   31,   19,   19,   39,
   41,   37,   38,   40,   40,   43,   42,   42,   42,
};
const short H5EDITyylen[] = {                                         2,
    0,    2,    2,    1,    1,    1,    1,    1,    1,    3,
    4,    2,    3,    1,    1,    2,    2,    1,    1,    1,
    1,    1,    1,    1,    3,    3,    2,    2,    1,    2,
    1,    1,    1,    1,    1,    4,    1,    2,    1,    1,
    1,    1,    2,    1,    1,    1,    1,    1,    2,    1,
    0,    5,    1,    0,    2,    2,    1,    2,    1,    0,
    0,    6,    1,    0,    2,    2,    1,    1,    1,
};
const short H5EDITyydefred[] = {                                      1,
    0,    0,    0,    2,    0,    4,    5,    6,    7,    8,
    9,    0,    0,   20,   21,   22,   23,    0,   18,   15,
    0,   24,    3,   16,   19,   17,    0,   10,    0,   14,
   13,    0,    0,    0,   41,   42,    0,   60,   48,   51,
   57,    0,    0,    0,   29,   31,   32,   33,   34,   35,
   44,   45,   46,   47,   50,    0,   59,   11,   30,   43,
   58,    0,    0,   49,   25,    0,   27,   28,    0,    0,
    0,   37,   39,   40,   67,   68,   69,   64,   63,   26,
   53,   54,   38,   36,    0,    0,    0,    0,   65,   52,
    0,   55,   66,   62,   56,
};
const short H5EDITyydgoto[] = {                                       1,
    4,    5,   23,    6,    7,    8,    9,   10,   11,   18,
   28,   29,   19,   20,   26,   42,   43,   44,   45,   46,
   47,   48,   49,   50,   71,   72,   77,   51,   52,   53,
   54,   55,   56,   82,   86,   92,   57,   78,   63,   85,
   88,   79,   89,
};
const short H5EDITyysindex[] = {                                      0,
 -244, -249, -249,    0, -267,    0,    0,    0,    0,    0,
    0, -241, -241,    0,    0,    0,    0, -115,    0,    0,
 -241,    0,    0,    0,    0,    0, -123,    0, -102,    0,
    0, -265, -293, -101,    0,    0,  -94,    0,    0,    0,
    0,  -95, -120, -122,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   -4,    0,    0,    0,    0,
    0, -271, -263,    0,    0, -122,    0,    0, -286, -285,
  -85,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   -3,  -13, -263,  -82,    0,    0,
 -280,    0,    0,    0,    0,
};
const short H5EDITyyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -224,    0,    0,    0,    0,    0,    6,    0,    0,    0,
    0,    0,    6,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    6,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -78,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
const short H5EDITyygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   45,
   20,   29,    2,   39,    0,    0,    0,    9,  -34,   21,
    0,    0,    0,    0,    0,    0,    0,   22,    0,    0,
    0,   14,    0,    0,    0,    0,   23,    0,    0,    0,
    0,  -31,    0,
};
#define YYTABLESIZE 208
const short H5EDITyytable[] = {                                      38,
   38,   22,   38,   73,   74,   35,   36,   27,   67,   68,
   12,   13,    2,    3,   25,   14,   15,   16,   17,   30,
   27,   38,   30,   14,   15,   16,   17,   90,   62,   65,
   91,   80,   39,   40,   41,   69,   70,   81,   83,   84,
   87,   37,   94,   95,   12,   51,   61,   21,   58,   31,
   24,   66,   59,   64,   60,   93,   61,    0,    0,    0,
   75,   76,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   32,   33,
   34,   34,   33,   34,    0,    0,    0,   35,   36,   14,
   15,   16,   17,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   37,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   39,   40,   41,   39,   40,   41,
};
const short H5EDITyycheck[] = {                                     123,
  123,  269,  123,  267,  268,  271,  272,  123,   43,   44,
  260,  261,  257,  258,   13,  265,  266,  267,  268,   18,
  123,  123,   21,  265,  266,  267,  268,   41,  123,  125,
   44,   66,  326,  327,  328,   40,  308,  324,  324,  125,
   44,  307,  125,  324,  269,   40,  125,    3,   29,   21,
   12,   43,   32,   40,   33,   87,   34,   -1,   -1,   -1,
  324,  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  263,
  264,  264,  263,  264,   -1,   -1,   -1,  271,  272,  265,
  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  307,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  326,  327,  328,  326,  327,  328,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 328
#if YYDEBUG
const char * const H5EDITyyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,"':'",0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"CREATE_KWORD","DELETE_KWORD","ATTRIBUTE_KWORD","DATASET_KWORD","GROUP_KWORD",
"DATATYPE_KWORD","DATASPACE_KWORD","DATA_KWORD","IDENTIFIER","PATHNAME",
"QUOTED_STRING","DQUOTED_STRING","EOSTMT_TOKEN","WSPACE","INTEGER_TYPE_TOKEN",
"FLOAT_TYPE_TOKEN","H5T_STD_I8BE_TOKEN","H5T_STD_I8LE_TOKEN",
"H5T_STD_I16BE_TOKEN","H5T_STD_I16LE_TOKEN","H5T_STD_I32BE_TOKEN",
"H5T_STD_I32LE_TOKEN","H5T_STD_I64BE_TOKEN","H5T_STD_I64LE_TOKEN",
"H5T_STD_U8BE_TOKEN","H5T_STD_U8LE_TOKEN","H5T_STD_U16BE_TOKEN",
"H5T_STD_U16LE_TOKEN","H5T_STD_U32BE_TOKEN","H5T_STD_U32LE_TOKEN",
"H5T_STD_U64BE_TOKEN","H5T_STD_U64LE_TOKEN","H5T_NATIVE_CHAR_TOKEN",
"H5T_NATIVE_SCHAR_TOKEN","H5T_NATIVE_UCHAR_TOKEN","H5T_NATIVE_SHORT_TOKEN",
"H5T_NATIVE_USHORT_TOKEN","H5T_NATIVE_INT_TOKEN","H5T_NATIVE_UINT_TOKEN",
"H5T_NATIVE_LONG_TOKEN","H5T_NATIVE_ULONG_TOKEN","H5T_NATIVE_LLONG_TOKEN",
"H5T_NATIVE_ULLONG_TOKEN","H5T_IEEE_F32BE_TOKEN","H5T_IEEE_F32LE_TOKEN",
"H5T_IEEE_F64BE_TOKEN","H5T_IEEE_F64LE_TOKEN","H5T_NATIVE_FLOAT_TOKEN",
"H5T_NATIVE_DOUBLE_TOKEN","H5T_NATIVE_LDOUBLE_TOKEN","H5T_STRING_TOKEN",
"STRSIZE_TOKEN","STRPAD_TOKEN","CSET_TOKEN","CTYPE_TOKEN","H5T_VARIABLE_TOKEN",
"H5T_STR_NULLTERM_TOKEN","H5T_STR_NULLPAD_TOKEN","H5T_STR_SPACEPAD_TOKEN",
"H5T_CSET_ASCII_TOKEN","H5T_CSET_UTF8_TOKEN","H5T_C_S1_TOKEN",
"H5T_FORTRAN_S1_TOKEN","H5T_COMPOUND_TOKEN","H5T_ARRAY_TOKEN","H5T_VLEN_TOKEN",
"STRING_CONST","INTEGER_CONST","FLOAT_CONST","SCALAR_TOKEN","SIMPLE_TOKEN",
"NULL_TOKEN",
};
const char * const H5EDITyyrule[] = {
"$accept : editstmts",
"editstmts :",
"editstmts : editstmts editstmt",
"editstmt : editcmd eostmt",
"editcmd : create_cmd",
"editcmd : delete_cmd",
"create_cmd : create_cmd1",
"create_cmd : create_cmd2",
"delete_cmd : delete_cmd1",
"delete_cmd : delete_cmd2",
"create_cmd1 : CREATE_KWORD targetobject attribute_definition",
"create_cmd2 : CREATE_KWORD targetobject attributename attribute_definition",
"delete_cmd1 : DELETE_KWORD targetobject",
"delete_cmd2 : DELETE_KWORD targetobject attributename",
"attributename : objectname",
"targetobject : datasetname",
"targetobject : DATASET_KWORD datasetname",
"targetobject : GROUP_KWORD groupname",
"datasetname : objectname",
"groupname : objectname",
"objectname : IDENTIFIER",
"objectname : PATHNAME",
"objectname : QUOTED_STRING",
"objectname : DQUOTED_STRING",
"eostmt : EOSTMT_TOKEN",
"attribute_definition : '{' attribute_body_definition '}'",
"attribute_body_definition : datatype_stmt dataspace_stmt data_stmt",
"attribute_body_definition : datatype_stmt data_stmt",
"attribute_body_definition : dataspace_stmt data_stmt",
"attribute_body_definition : data_stmt",
"datatype_stmt : DATATYPE_KWORD datatype_definition",
"datatype_stmt : datatype_definition",
"datatype_definition : datatype_class",
"datatype_class : integer_class",
"datatype_class : floatpoint_class",
"datatype_class : string_class",
"string_class : H5T_STRING_TOKEN '{' string_type_definition '}'",
"string_type_definition : string_size_definition",
"string_size_definition : STRSIZE_TOKEN INTEGER_CONST",
"string_const : QUOTED_STRING",
"string_const : DQUOTED_STRING",
"integer_class : INTEGER_TYPE_TOKEN",
"floatpoint_class : FLOAT_TYPE_TOKEN",
"dataspace_stmt : DATASPACE_KWORD dataspace_definition",
"dataspace_stmt : dataspace_definition",
"dataspace_definition : dataspace_simple",
"dataspace_definition : dataspace_scalar",
"dataspace_definition : dataspace_null",
"dataspace_scalar : SCALAR_TOKEN",
"dataspace_simple : SIMPLE_TOKEN dataspace_dims_list",
"dataspace_simple : dataspace_dims_list",
"$$1 :",
"dataspace_dims_list : $$1 '(' dim_firstone dims_list ')'",
"dim_firstone : INTEGER_CONST",
"dims_list :",
"dims_list : dims_list dim_more",
"dim_more : ',' INTEGER_CONST",
"dataspace_null : NULL_TOKEN",
"data_stmt : DATA_KWORD data_definition",
"data_stmt : data_definition",
"$$2 :",
"$$3 :",
"data_definition : '{' $$2 data_firstval data_list $$3 '}'",
"data_firstval : data_val",
"data_list :",
"data_list : data_list data_more",
"data_more : ',' data_val",
"data_val : INTEGER_CONST",
"data_val : FLOAT_CONST",
"data_val : string_const",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 10:
#line 166 "parse.y"
{
			    if (get_debug()) printf("found create commnad syntax 1\n");
			    /* error check */
			    if (!dataset_name && !group_name){
				fprintf(stderr, "neither dataset nor group name is provided for CREATE command\n");
				leave(EXIT_FAILURE);
			    }
			    /* Execute the CREATE command */
			    /* Sending NULL for attribute_name because it is not defined. */
			    create_attribute(NULL, group_name, dataset_name,
				attribute_type_id, attribute_space_id, &attribute_data);
			    /* Cleanup */
			    if (group_name){
				HDfree(group_name);
				group_name = NULL;
			    }
			    if (dataset_name){
				HDfree(dataset_name);
				dataset_name = NULL;
			    }
			    attribute_data_needed = -1;

			    if (attribute_space_id >= 0){
				H5Sclose(attribute_space_id);
				attribute_space_id = -1;
			    }
			    if (attribute_type_id >= 0){
				H5Tclose(attribute_type_id);
				attribute_type_id = -1;
			    }
			    attribute_type_class = H5T_NO_CLASS;
			}
break;
case 11:
#line 201 "parse.y"
{
			    if (get_debug()) printf("found create commnad\n");
			    /* error check */
			    if (!attribute_name){
				fprintf(stderr, "attribute name missing from CREATE command\n");
				leave(EXIT_FAILURE);
			    }
			    if (!dataset_name && !group_name){
				fprintf(stderr, "neither dataset nor group name is provided for CREATE command\n");
				leave(EXIT_FAILURE);
			    }
			    /* Execute the CREATE command */
			    create_attribute(attribute_name, group_name, dataset_name,
				attribute_type_id, attribute_space_id, &attribute_data);
			    /* Cleanup */
			    HDfree(attribute_name);
			    attribute_name = NULL;
			    if (group_name){
				HDfree(group_name);
				group_name = NULL;
			    }
			    if (dataset_name){
				HDfree(dataset_name);
				dataset_name = NULL;
			    }
			    attribute_data_needed = -1;

			    if (attribute_space_id >= 0){
				H5Sclose(attribute_space_id);
				attribute_space_id = -1;
			    }
			    if (attribute_type_id >= 0){
				H5Tclose(attribute_type_id);
				attribute_type_id = -1;
			    }
			    attribute_type_class = H5T_NO_CLASS;
			}
break;
case 12:
#line 242 "parse.y"
{
			    if (get_debug()) printf("found delete commnad syntax 1\n");
			    /* error check */
			    if (!dataset_name && !group_name){
				fprintf(stderr, "neither dataset nor group name is provided for DELETE command\n");
				leave(EXIT_FAILURE);
			    }
			    /* Execute the DELETE command */
			    /* Sending NULL for attribute_name because it is not defined. */
			    delete_attribute(NULL, group_name, dataset_name);
			    /* Cleanup */
			    if (group_name){
				HDfree(group_name);
				group_name = NULL;
			    }
			    if (dataset_name){
				HDfree(dataset_name);
				dataset_name = NULL;
			    }
			}
break;
case 13:
#line 265 "parse.y"
{
			    if (get_debug()) printf("found delete commnad\n");
			    /* error check */
			    if (!attribute_name){
				fprintf(stderr, "attribute name missing from DELETE command\n");
				leave(EXIT_FAILURE);
			    }
			    if (!dataset_name && !group_name){
				fprintf(stderr, "neither dataset nor group name is provided for DELETE command\n");
				leave(EXIT_FAILURE);
			    }
			    /* Execute the DELETE command */
			    delete_attribute(attribute_name, group_name, dataset_name);
			    /* Cleanup */
			    HDfree(attribute_name);
			    attribute_name = NULL;
			    if (group_name){
				HDfree(group_name);
				group_name = NULL;
			    }
			    if (dataset_name){
				HDfree(dataset_name);
				dataset_name = NULL;
			    }
			}
break;
case 14:
#line 292 "parse.y"
{if (get_debug()) printf("got attribute name(%s)\n", H5EDITyylval.sval);
			    /* save the attribute name */
			    if (attribute_name != NULL){
				fprintf(stderr, "Already got an attribute name\n");
				leave(EXIT_FAILURE);
			    }
			    if ((attribute_name = HDstrdup(H5EDITyylval.sval)) == NULL){
				fprintf(stderr, "strdup failed\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 18:
#line 311 "parse.y"
{if (get_debug()) printf("got dataset name(%s)\n", H5EDITyylval.sval);
			    /* save the dataset name */
			    if (dataset_name != NULL){
				fprintf(stderr, "Already got an dataset name\n");
				leave(EXIT_FAILURE);
			    }
			    if ((dataset_name = HDstrdup(H5EDITyylval.sval)) == NULL){
				fprintf(stderr, "strdup failed\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 19:
#line 325 "parse.y"
{if (get_debug()) printf("got group name(%s)\n", H5EDITyylval.sval);
			    /* save the group name */
			    if (group_name != NULL){
				fprintf(stderr, "Already got an group name\n");
				leave(EXIT_FAILURE);
			    }
			    if ((group_name = HDstrdup(H5EDITyylval.sval)) == NULL){
				fprintf(stderr, "strdup failed\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 25:
#line 351 "parse.y"
{ if (get_debug()) printf("found attribute definition\n");

			}
break;
case 36:
#line 376 "parse.y"
{
			    if (get_debug()) printf("found string type\n");
			    if (attribute_type_class != H5T_NO_CLASS){
				fprintf(stderr, "Already has an attribute data type\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_type_class = H5T_STRING;
			    /* for now, assume it is null-terminated strings */
			    if ((attribute_type_id=H5Tcopy(H5T_C_S1)) < 0){
				fprintf(stderr, "Attribute string type create failure\n");
				leave(EXIT_FAILURE);
			    }
			    if (H5Tset_size(attribute_type_id,str_size) < 0){
				fprintf(stderr, "Attribute string size set failure\n");
				leave(EXIT_FAILURE);
			    }
			    if (H5Tset_strpad(attribute_type_id, H5T_STR_NULLTERM) < 0){
				fprintf(stderr, "Attribute string pad set failure\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 37:
#line 400 "parse.y"
{
			    if (get_debug()) printf("found string size\n");
			}
break;
case 38:
#line 406 "parse.y"
{   /* Must test value range before assign it to str_zize */
			    /* which is size_t type which is unsigned. */
			    if (get_debug()) printf("String size is (%d)\n",
				    H5EDITyylval.ival);
			    if (H5EDITyylval.ival <= 0){
				fprintf(stderr, "String size must be positive (%d)\n",
				    H5EDITyylval.ival);
				leave(EXIT_FAILURE);
			    }
			    str_size = H5EDITyylval.ival;
			}
break;
case 41:
#line 424 "parse.y"
{
			    if (get_debug()) printf("found integer type(%s)\n",
				H5EDITyylval.sval);
			    if (attribute_type_class != H5T_NO_CLASS){
				fprintf(stderr, "Already has an attribute data type\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_type_class = H5T_INTEGER;
			    if ((attribute_type_id=H5LTtext_to_dtype(H5EDITyylval.sval, H5LT_DDL)) < 0){
				fprintf(stderr, "Attribute type create failure\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 42:
#line 440 "parse.y"
{
			    if (get_debug()) printf("found float type(%s)\n",
				H5EDITyylval.sval);
			    if (attribute_type_class != H5T_NO_CLASS){
				fprintf(stderr, "Already has an attribute data type\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_type_class = H5T_FLOAT;
			    if ((attribute_type_id=H5LTtext_to_dtype(H5EDITyylval.sval, H5LT_DDL)) < 0){
				fprintf(stderr, "Attribute type create failure\n");
				leave(EXIT_FAILURE);
			    }
			}
break;
case 48:
#line 466 "parse.y"
{
			    if (get_debug()) printf("found scalar dataspace\n");
			    attribute_space_class = H5S_SCALAR;
			    if (attribute_space_id != -1){
				fprintf(stderr, "Already has an attribute space\n");
				leave(EXIT_FAILURE);
			    }
			    if ((attribute_space_id=H5Screate(H5S_SCALAR)) < 0){
				fprintf(stderr, "Attribute space create failure\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_data_needed = 1;
			}
break;
case 51:
#line 487 "parse.y"
{
			    if (get_debug()) printf("looking for dimlist\n");
			    attribute_space_class = H5S_SIMPLE;
			    /* reset attribute dimension information */
			    HDmemset(&attribute_dims, 0, sizeof(attribute_dims));
			}
break;
case 52:
#line 495 "parse.y"
{
			    if (get_debug()){
				int i;
				printf("found simple dataspace\n");
				printf("rank=%d:\n", attribute_dims.ndims);
				for (i=0; i<attribute_dims.ndims; i++){
				    printf("%ld\n", (long) attribute_dims.dims[i]);
				}
			    }
			    if (attribute_space_id != -1){
				fprintf(stderr, "Already has an attribute space\n");
				leave(EXIT_FAILURE);
			    }
			    if ((attribute_space_id=H5Screate_simple(attribute_dims.ndims,
				    &(attribute_dims.dims), NULL)) < 0 ){
				fprintf(stderr, "Attribute space create failure\n");
				leave(EXIT_FAILURE);
			    }
			    /* Calculate number of data elements needed */
			    attribute_data_needed = attribute_dims.dims[0];
			    {   int i;
				for (i=1; i < attribute_dims.ndims; i++){
				    attribute_data_needed *= attribute_dims.dims[i];
				}
				if (get_debug()) printf("attribute data needed=%d\n",
					attribute_data_needed);
			    }
			    /* AKC: I don't like the coding here. */
			    /* It is repeating code.  Need to fix it later. */
			    /* Default datatype is Native Float */
			    if ( attribute_type_class == H5T_NO_CLASS){
				attribute_type_class = H5T_FLOAT;
				if ((attribute_type_id=H5Tcopy(H5T_NATIVE_FLOAT)) < 0){
				    fprintf(stderr, "Attribute default type create failure\n");
				    leave(EXIT_FAILURE);
				}
			    }
			    switch (attribute_type_class){
			    case H5T_INTEGER:
			    case H5T_FLOAT:
				if (attribute_data_needed > DATA_SIZE_MAX){
				    fprintf(stderr,
					"Too many attribute data needed(%d). "
					"Maximum is %d\n",
					attribute_data_needed, DATA_SIZE_MAX);
				    leave(EXIT_FAILURE);
				}
				break;
			    case H5T_STRING:
				if ((attribute_data_needed*str_size) > sizeof(attribute_data)){
				    fprintf(stderr,
					"Too much attribute string data needed(%d). "
					"Maximum is %d\n",
					(int)attribute_data_needed*str_size,
					sizeof(attribute_data));
				    leave(EXIT_FAILURE);
				}
				break;
			    default:
				fprintf(stderr, "Unsupported data type(%d)\n",
				    attribute_type_class);
				leave(EXIT_FAILURE);
			    }
			}
break;
case 53:
#line 562 "parse.y"
{   /* first dimension */
			    if (H5EDITyylval.ival <=0){
				fprintf(stderr, "Dimension must be positive. Got %d.\n",
				    H5EDITyylval.ival);
				leave(EXIT_FAILURE);
			    }
			    attribute_dims.dims[attribute_dims.ndims] = H5EDITyylval.ival;
			    attribute_dims.ndims++;
			}
break;
case 56:
#line 578 "parse.y"
{   /* more dimensions */
			    if (attribute_dims.ndims >= H5S_MAX_RANK){
				fprintf(stderr, "Too many dimensions. Maximun is %d\n",
				    H5S_MAX_RANK);
				leave(EXIT_FAILURE);
			    }
			    if (H5EDITyylval.ival <=0){
				fprintf(stderr, "Dimension must be positive. Got %d.\n",
				    H5EDITyylval.ival);
				leave(EXIT_FAILURE);
			    }
			    attribute_dims.dims[attribute_dims.ndims] = H5EDITyylval.ival;
			    attribute_dims.ndims++;
			}
break;
case 60:
#line 603 "parse.y"
{
			    /* get the data buffer ready for new data */
			    if (get_debug()) printf("found attribute data\n");
			    attribute_data_gotten = 0;
			    attribute_data_pt = &(attribute_data.data_string);
			    /* Default datatype is Native Float */
			    if ( attribute_type_class == H5T_NO_CLASS){
				attribute_type_class = H5T_FLOAT;
				if ((attribute_type_id=H5Tcopy(H5T_NATIVE_FLOAT)) < 0){
				    fprintf(stderr, "Attribute default type create failure\n");
				    leave(EXIT_FAILURE);
				}
			    }
			    /* Default dataspace is SCALAR */
			    if (attribute_space_id == -1){
				attribute_space_class = H5S_SCALAR;
				if ((attribute_space_id=H5Screate(H5S_SCALAR)) < 0){
				    fprintf(stderr, "Attribute default space create failure\n");
				    leave(EXIT_FAILURE);
				}
				attribute_data_needed = 1;
			    }
			}
break;
case 61:
#line 627 "parse.y"
{
			    if (attribute_data_gotten < attribute_data_needed){
				fprintf(stderr, "Fewer data than needed. "
				    "Need %d but got %d data only\n",
				    attribute_data_needed, attribute_data_gotten);
				leave(EXIT_FAILURE);
			    }
			}
break;
case 62:
#line 636 "parse.y"
{ /* no action */
			}
break;
case 67:
#line 651 "parse.y"
{
			    if (attribute_data_gotten >= attribute_data_needed){
				fprintf(stderr, "More data than needed. Only %d are needed.\n",
				    attribute_data_needed);
				leave(EXIT_FAILURE);
			    }
			    if (attribute_type_class != H5T_INTEGER){
				fprintf(stderr, "Gotten incorrect type of data\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_data.data_int[attribute_data_gotten++] = H5EDITyylval.ival;
			}
break;
case 68:
#line 665 "parse.y"
{
			    if (attribute_data_gotten >= attribute_data_needed){
				fprintf(stderr, "More data than needed. Only %d are needed.\n",
				    attribute_data_needed);
				leave(EXIT_FAILURE);
			    }
			    if (attribute_type_class != H5T_FLOAT){
				fprintf(stderr, "Gotten incorrect type of data\n");
				leave(EXIT_FAILURE);
			    }
			    attribute_data.data_float[attribute_data_gotten++] = H5EDITyylval.fval;
			}
break;
case 69:
#line 678 "parse.y"
{
			    if (attribute_data_gotten >= attribute_data_needed){
				fprintf(stderr, "More data than needed. Only %d are needed.\n",
				    attribute_data_needed);
				leave(EXIT_FAILURE);
			    }
			    if (attribute_type_class != H5T_STRING){
				fprintf(stderr, "Gotten incorrect type of data\n");
				leave(EXIT_FAILURE);
			    }
			    switch (attribute_space_class) {
			    case H5S_SCALAR:
				/* this works for scalar only. Copy the
				 * string_const to attribute_data. */
				if (attribute_data_gotten > 0 ){
				    fprintf(stderr, "More data than needed. Only %d are needed.\n",
					attribute_data_needed);
				    leave(EXIT_FAILURE);
				}
				HDstrncpy(attribute_data_pt, H5EDITyylval.sval, str_size);
				/* move data pointer forward */
				attribute_data_pt += str_size;
				attribute_data_gotten++;
				break;
			    case H5S_SIMPLE:
				/* This should work for SIMPLE space */
				/* this is not working
				fprintf(stderr, "not able to support string type of SIMPLE space\n");
				leave(EXIT_FAILURE);
				*/
				HDstrncpy(attribute_data_pt, H5EDITyylval.sval, str_size);
				/* move data pointer forward */
				attribute_data_pt += str_size;
				attribute_data_gotten++;
				break;
			    default:
				fprintf(stderr, "Do not know how to store string_const "
				    "of this kind of data space(%d)\n",
				    attribute_space_class);
				leave(EXIT_FAILURE);
			    }
			}
break;
#line 1138 "parse.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
